#include "opps.h"

/*  GWOPPS examples  */
/*  ZB123Y's radial view */

FormPzb123yR(D,D1,D2,B,R1,R2,C,C1,C2,d3,d2,L,b,e1,e2)
double D,D1,D2,B,R1,R2,C,C1,C2,d3,d2,L,b,e1,e2;
{
double temp;
    ptArray[0].x= - L - e1 ;
    ptArray[0].y= 0.0;
    ptArray[1].x= e1 ;
    ptArray[1].y= 0.0;
    ptArray[2].x= - L ;
    ptArray[2].y= b / 2.0 ;
    ptArray[3].x= C2 - L ;
    ptArray[3].y= b / 2.0 ;
    ptArray[4].x= 0.0 ;
    ptArray[4].y= b / 2.0 ;
    ptArray[5].x= 0.0 ;
    ptArray[5].y= ( D1 - d3 ) / 2.0 - R2 ;
    ptArray[6].x= 0.0 ;
    ptArray[6].y= d2 / 2.0 ;
    ptArray[7].x= C2 - L ;
    ptArray[7].y= d2 / 2.0 ;
    ptArray[8].x= - L ;
    ptArray[8].y= d2 / 2.0 + C2 ;
    ptArray[9].x= - L ;
    ptArray[9].y= D2 / 2.0 - C1 ;
    ptArray[10].x= C1 - L ;
    ptArray[10].y= D2 / 2.0 ;
    ptArray[11].x= - B - R1 ;
    ptArray[11].y= D2 / 2.0 ;
    ptArray[12].x= - B ;
    ptArray[12].y= D2 / 2.0 + R1 ;
    ptArray[13].x= - B ;
    ptArray[13].y= ( D1 - d3 ) / 2.0 ;
    ptArray[14].x= - R2 ;
    ptArray[14].y= ( D1 - d3 ) / 2.0 ;
    ptArray[15].x= - L ;
    ptArray[15].y= ptArray[14].y ;
    ptArray[16].x= 0.0 ;
    ptArray[16].y= ( D1 + d3 ) / 2.0 + R2 ;
    ptArray[17].x= 0.0 ;
    ptArray[17].y= D / 2.0 ;
    ptArray[18].x= C - B ;
    ptArray[18].y= D / 2.0 ;
    ptArray[19].x= - B ;
    ptArray[19].y= D / 2.0 - C ;
    ptArray[20].x= - B ;
    ptArray[20].y= ( D1 + d3 ) / 2.0 ;
    ptArray[21].x= - R2 ;
    ptArray[21].y= ptArray[20].y ;
    ptArray[22].x= - B - e2 ;
    ptArray[22].y= D1 / 2.0 ;
    ptArray[23].x= e2 ;
    ptArray[23].y= D1 / 2.0 ;
    ptArray[24].x= ptArray[6].x ;
    ptArray[24].y= - ptArray[6].y ;
    ptArray[25].x= ptArray[8].x ;
    ptArray[25].y= - ptArray[8].y ;
    ptArray[26].x= ptArray[17].x ;
    ptArray[26].y= - ptArray[17].y ;
    ptArray[27].x= ptArray[19].x;
    ptArray[27].y= - ptArray[19].y;
    ptArray[28].x= 3.0*e1 ;
    ptArray[28].y= ptArray[17].y ;
    ptArray[29].x= 0.0 ;
    ptArray[29].y= - D / 2.0 - 3.0 * e1 ;
    ptArray[30].x= ptArray[9].x ;
    ptArray[30].y= - ptArray[9].y ;
    ptArray[31].x= 0.0 ;
    ptArray[31].y= ptArray[29].y - 3.0 * e1 ;
    ptArray[32].x= ptArray[7].x ;
    ptArray[32].y= - ptArray[7].y ;
    ptArray[33].x= - L -3.0 * e1 ;
    ptArray[33].y= ptArray[7].y ;
    ptArray[34].x= ptArray[10].x ;
    ptArray[34].y= - ptArray[10].y ;
    ptArray[35].x= - L - 6.0 * e1 ;
    ptArray[35].y= ptArray[10].y ;
    ptArray[36].x= ptArray[22].x ;
    ptArray[36].y= - ptArray[22].y ;
    ptArray[37].x= - L - 9.0 * e1 ;
    ptArray[37].y= ptArray[22].y ;
    ptArray[38].x= e2 ;
    ptArray[38].y= D / 2.0 ;
    ptArray[39].x= ptArray[15].x ;
    ptArray[39].y= - ptArray[15].y ;
    ptArray[40].x= ptArray[20].x ;
    ptArray[40].y= - ptArray[20].y ;
    Ospace[0] = floor(B / 5.0) ;   /*  Decide space of hatching area */
    Ospace[1] = Ospace[0];
    Ospace[2] = Ospace[0];
    Ospace[3] = Ospace[0];
    return(0);
}

/*  ZB123ZJ's radial view */

FormPzb123zjR(D,D1,D2,B,R1,R2,C,C1,C2,d3,D3,D4,D5,B1,R3,C3,
              d2,L,l,b,e1,e2,zjflag)
double D,D1,D2,B,R1,R2,C,C1,C2,d3,D3,D4,D5,B1,R3,C3,d2,L,l,b,e1,e2;
int    zjflag;
{
double temp;
    ptArray[0].x= - L - e1 ;
    ptArray[0].y= 0.0;
    ptArray[1].x= e1 ;
    ptArray[1].y= 0.0;
    ptArray[2].x= - L ;
    ptArray[2].y= b / 2.0 ;
    ptArray[3].x= C2 - L ;
    ptArray[3].y= b / 2.0 ;
    ptArray[4].x= - l ;
    ptArray[4].y= b / 2.0 ;
    ptArray[5].x= - l ;
    ptArray[5].y= D5 / 2.0 ;
    ptArray[6].x= - l ;
    if (zjflag == 0)
    {
        ptArray[6].y= d2 / 2.0 ;
        ptArray[7].y= d2 / 2.0 ;
    }
    else
    {
        ptArray[6].y= ( d2 - 0.5 ) / 2.0 - ( L - l -C2 ) / 10.0 ;
        ptArray[7].y= ( d2 - 0.5 ) / 2.0 ;
    }
    ptArray[7].x= C2 - L ;
    ptArray[8].x= - L ;
    ptArray[8].y= d2 / 2.0 + C2 ;
    ptArray[9].x= - L ;
    ptArray[9].y= D2 / 2.0 - C1 ;
    ptArray[10].x= C1 - L ;
    ptArray[10].y= D2 / 2.0 ;
    ptArray[11].x= - B1 - R1 ;
    ptArray[11].y= D2 / 2.0 ;
    ptArray[12].x= - B1 ;
    ptArray[12].y= ptArray[11].y + R1 ;
    ptArray[13].x= - B1 ;
    ptArray[13].y= D3 / 2.0 - C3 ;
    ptArray[14].x= C3 - B1 ;
    ptArray[14].y= D3 / 2.0 ;
    ptArray[15].x= - B - R3 ;
    ptArray[15].y= D3 / 2.0 ;
    ptArray[16].x= - B ;
    ptArray[16].y= D3 / 2.0 + R3 ;
    ptArray[17].x= - B ;
    ptArray[17].y= ( D1 - d3 ) / 2.0 ;
    ptArray[18].x= - R2 ;
    ptArray[18].y= ( D1 - d3 ) / 2.0 ;
    ptArray[19].x= 0.0 ;
    ptArray[19].y= ptArray[18].y - R2 ;
    ptArray[20].x= 0.0 ;
    ptArray[20].y= D4 / 2.0 ;
    ptArray[21].x= - L ;
    ptArray[21].y= ptArray[6].y ;
    ptArray[22].x= 0.0 ;
    ptArray[22].y= ( D1 - d3 ) / 2.0 ;
    ptArray[23].x= - C ;
    ptArray[23].y= D / 2.0 ;
    ptArray[24].x= C - B ;
    ptArray[24].y= D / 2.0 ;
    ptArray[25].x= - B ;
    ptArray[25].y= D / 2.0 - C ;
    ptArray[26].x= - B ;
    ptArray[26].y= ( D1 + d3 ) / 2.0 ;
    ptArray[27].x= - R2 ;
    ptArray[27].y= ptArray[26].y ;
    ptArray[28].x= 0.0 ;
    ptArray[28].y= ( D1 + d3 ) / 2.0 + R2 ;
    ptArray[29].x= 0.0 ;
    ptArray[29].y= D / 2.0 - C ;
    ptArray[30].x= e2 ;
    ptArray[30].y= D / 2.0 ;
    ptArray[31].x= - B - e2 ;
    ptArray[31].y= D1 / 2.0 ;
    ptArray[32].x= e2 ;
    ptArray[32].y= D1 / 2.0 ;
    ptArray[33].x= - L ;
    ptArray[33].y= - ptArray[17].y ;
    ptArray[34].x= 0.0 ;
    ptArray[34].y= - ptArray[6].y ;
    ptArray[35].x= ptArray[26].x ;
    ptArray[35].y= - ptArray[26].y ;
    ptArray[36].x= ptArray[30].x ;
    ptArray[36].y= - ptArray[30].y ;
    ptArray[37].x= ptArray[6].x ;
    ptArray[37].y= - ptArray[6].y ;
    ptArray[38].x= ptArray[8].x ;
    ptArray[38].y= - ptArray[8].y ;
    ptArray[39].x= ptArray[20].x ;
    ptArray[39].y= - ptArray[20].y ;
    ptArray[40].x= ptArray[5].x ;
    ptArray[40].y= - ptArray[5].y ;
    ptArray[41].x= 3.0 * e1 ;
    ptArray[41].y= ptArray[5].y ;
    ptArray[42].x= ptArray[41].x + 3.0 * e1 ;
    ptArray[42].y= ptArray[20].y ;
    ptArray[43].x= ptArray[23].x ;
    ptArray[43].y= - ptArray[23].y ;
    ptArray[44].x= ptArray[41].x + 6.0 * e1 ;
    ptArray[44].y= ptArray[30].y ;
    ptArray[45].x= ptArray[29].x ;
    ptArray[45].y= - ptArray[29].y ;
    ptArray[46].x= ptArray[25].x ;
    ptArray[46].y= - ptArray[25].y ;
    ptArray[47].x= 0.0 ;
    ptArray[47].y= ptArray[43].y - 3.0 * e1 ;
    ptArray[48].x= ptArray[13].x ;
    ptArray[48].y= - ptArray[13].y ;
    ptArray[49].x= 0.0 ;
    ptArray[49].y= ptArray[47].y - 3.0 * e1 ;
    ptArray[50].x= ptArray[9].x ;
    ptArray[50].y= - ptArray[9].y ;
    ptArray[51].x= 0.0 ;
    ptArray[51].y= ptArray[49].y - 3.0 * e1 ;
    ptArray[52].x= ptArray[7].x ;
    ptArray[52].y= - ptArray[7].y ;
    ptArray[53].x= ptArray[8].x - 3.0 * e1 ;
    ptArray[53].y= ptArray[7].y ;
    ptArray[54].x= ptArray[10].x ;
    ptArray[54].y= - ptArray[10].y ;
    ptArray[55].x= ptArray[53].x - 3.0 * e1 ;
    ptArray[55].y= ptArray[10].y ;
    ptArray[56].x= ptArray[14].x ;
    ptArray[56].y= - ptArray[14].y ;
    ptArray[57].x= ptArray[55].x - 3.0 * e1 ;
    ptArray[57].y= ptArray[14].y ;
    ptArray[58].x= ptArray[31].x ;
    ptArray[58].y= - ptArray[31].y ;
    ptArray[59].x= ptArray[57].x - 3.0 * e1 ;
    ptArray[59].y= ptArray[31].y ;
    Ospace[0] = floor(B / 5.0) ;
    Ospace[1] = Ospace[0];
    Ospace[2] = Ospace[0];
    Ospace[3] = Ospace[0];
    return(0);
}

/*  ZB123Y's axial view */

FormPzb123yX(D,D1,D2,C,C1,C2,f,f1,d2,d3,d4,b,t1,e1,e2)
double D,D1,D2,C,C1,C2,f,f1,d2,d3,d4,b,t1,e1,e2;
{
double temp,temp1;

    temp = f * PI / 180.0 ;
    ptArray[0].x= 0.0;
    ptArray[0].y= 0.0;
    ptArray[1].x= D / 2.0 + e1 ;
    ptArray[1].y= 0.0 ;
    ptArray[2].x= - D / 2.0 - e1 ;
    ptArray[2].y= 0.0;
    ptArray[3].x= 0.0 ;
    ptArray[3].y= D / 2.0 + e1 ;
    ptArray[4].x= 0.0;
    ptArray[4].y= - D / 2.0 - e1 ;
    ptArray[5].x= D / 2.0 ;
    ptArray[5].y= 0.0 ;
    ptArray[6].x= D / 2.0 - C ;
    ptArray[6].y= 0.0 ;
    ptArray[7].x= D1 / 2.0 ;
    ptArray[7].y= 0.0 ;
    ptArray[8].x= D2 / 2.0 ;
    ptArray[8].y= 0.0 ;
    ptArray[9].x= D2 / 2.0 - C1 ;
    ptArray[9].y= 0.0 ;
    ptArray[10].x= - sqrt( d2 * d2 - b * b ) / 2.0 ;
    ptArray[10].y= - b / 2.0 ;
    ptArray[11].x= ptArray[10].x ;
    ptArray[11].y= b / 2.0 ;
    ptArray[12].x= - sqrt((d2 * 0.5 + C2) * (d2 * 0.5 + C2) - b * b * 0.25) ;
    ptArray[12].y= - b / 2.0 ;
    ptArray[13].x= ptArray[12].x ;
    ptArray[13].y= b / 2.0 ;
    ptArray[14].x= d2 / 2.0 - t1 ;
    ptArray[14].y= - b / 2.0 ;
    ptArray[15].x= ptArray[14].x ;
    ptArray[15].y= b / 2.0 ;
    ptArray[16].x= 0.0 ;
    ptArray[16].y= - D1 / 2.0 ;
    ptArray[17].x= 0.0 ;
    ptArray[17].y= ptArray[16].y + d3 / 2.0 ;
    ptArray[18].x= 0.0 ;
    ptArray[18].y= ptArray[17].y + e2 ;
    ptArray[19].x= 0.0 ;
    ptArray[19].y= ptArray[16].y - d3 / 2.0 - e2 ;
    ptArray[20].x= - d3 / 2.0 ;
    ptArray[20].y= ptArray[19].y ;
    ptArray[21].x= d3 / 2.0 ;
    ptArray[21].y= ptArray[18].y ;
    ptArray[22].x= - D1 / 2.0 * sin(temp) ;
    ptArray[22].y= - D1 / 2.0 * cos(temp) ;
    ptArray[23].x= - ( D1 - d4 ) / 2.0 * sin(temp) ;
    ptArray[23].y= - ( D1 - d4 ) / 2.0 * cos(temp) ;
    ptArray[24].x= - (( D1 - d4 ) / 2.0 - e2 ) * sin(temp) ;
    ptArray[24].y= - (( D1 - d4 ) / 2.0 - e2 ) * cos(temp) ;
    ptArray[25].x= - (( D1 - d4 ) / 2.0 - 2.0 * e2 ) * sin(temp) ;
    ptArray[25].y= - (( D1 - d4 ) / 2.0 - 2.0 * e2 ) * cos(temp) ;
    ptArray[26].x= - (( D1 + d4 ) / 2.0 + 2.0 * e2 ) * sin(temp) ;
    ptArray[26].y= - (( D1 + d4 ) / 2.0 + 2.0 * e2 ) * cos(temp) ;
    ptArray[27].x= ptArray[26].x - d3 / 2.0 ;
    ptArray[27].y= ptArray[26].y ;
    ptArray[28].x= ptArray[25].x + d3 / 2.0 ;
    ptArray[28].y= ptArray[25].y ;
    temp1 = f1 * PI / 180.0;
    temp1 = ( temp + temp1 ) ;
    ptArray[29].x= - ( D / 2.0 + 5.0 * e1 ) * sin(temp / 2.0) ;
    ptArray[29].y= - ( D / 2.0 + 5.0 * e1 ) * cos(temp / 2.0) ;
    ptArray[30].x= - (( D1 - d4 ) / 2.0 - 2.0 * e1 ) * sin(temp1) ;
    ptArray[30].y= - (( D1 - d4 ) / 2.0 - 2.0 * e1 ) * cos(temp1) ;
    ptArray[31].x= - (( D1 + d4 ) / 2.0 + 2.0 * e1 ) * sin(temp1) ;
    ptArray[31].y= - (( D1 + d4 ) / 2.0 + 2.0 * e1 ) * cos(temp1) ;
    ptArray[32].x= - ( D / 2.0 + 5.0 * e1 ) * sin((temp + temp1) / 2.0) ;
    ptArray[32].y= - ( D / 2.0 + 5.0 * e1 ) * cos((temp + temp1) / 2.0) ;
    return(0);
}


/*  ZB80's radial view , there is not axial view  */

FormPzb80R(D,D1,D2,D3,C,C1,B2,B3,B4,B6,B7,L,h,h1,h2,H,H1,H2,b,
           R1,R2,R6,d1,e1)
double D,D1,D2,D3,C,C1,B2,B3,B4,B6,B7,L,h,h1,h2,H,H1,H2,b;
double R1,R2,R6,d1,e1;
{

    ptArray[0].x= 0.0 ;
    ptArray[0].y= H2 + e1 ;
    ptArray[1].x= 0.0 ;
    ptArray[1].y= - e1 ;
    ptArray[2].x=  C / 2.0 ;
    ptArray[2].y= h + e1 ;
    ptArray[3].x=  C / 2.0  ;
    ptArray[3].y= - e1 ;
    ptArray[4].x= C1 / 2.0 ;
    ptArray[4].y= H + e1 ;
    ptArray[5].x= C1 / 2.0 ;
    ptArray[5].y= e1 - h1 ;
    ptArray[6].x= - C / 2.0 ;
    ptArray[6].y= h + e1 ;
    ptArray[7].x=  - C / 2.0 ;
    ptArray[7].y= - e1 ;
    ptArray[8].x= 0.0 ;
    ptArray[8].y= 0.0 ;
    ptArray[9].x= B7 / 2.0 ;
    ptArray[9].y= 0.0  ;
    ptArray[10].x=  B7 / 2.0 ;
    ptArray[10].y= h1 - R1 ;
    ptArray[11].x=  B7 / 2.0 ;
    ptArray[11].y= h1 + h2 - R1 ;
    ptArray[12].x=  B7 / 2.0  + R1 ;
    ptArray[12].y= h1 + h2 ;
    ptArray[13].x= ( C1 - d1 ) / 2.0 ;
    ptArray[13].y=  h1 + h2 ;
    ptArray[14].x= ( C1 - d1 ) / 2.0 ;
    ptArray[14].y=  H ;
    ptArray[15].x= D1 / 2.0 ;
    ptArray[15].y= H ;
    ptArray[16].x= 0.0 ;
    ptArray[16].y= H - D1 / 2.0 ;
    ptArray[17].x= 0.0 ;
    ptArray[17].y= H ;
    ptArray[18].x= L / 2.0 - B6 ;
    ptArray[18].y=  0.0 ;
    ptArray[19].x= L / 2.0 - B6 ;
    ptArray[19].y= h1 - R1 ;
    ptArray[20].x=  C / 2.0 - ( 2.0 * R2 + b) / 2.0 ;
    ptArray[20].y= 0.0 ;
    ptArray[21].x= ptArray[20].x ;
    ptArray[21].y= h ;
    ptArray[22].x= B4 / 2.0 + R1 ;
    ptArray[22].y= h ;
    ptArray[23].x= B4 / 2.0  ;
    ptArray[23].y= h + R1 ;
    ptArray[24].x= B4 / 2.0  ;
    ptArray[24].y= H2 ;
    ptArray[25].x= B3 / 2.0 ;
    ptArray[25].y= H2 ;
    ptArray[26].x= B3 / 2.0 ;
    ptArray[26].y= H ;
    ptArray[27].x= ( C1 + d1 ) / 2.0 ;
    ptArray[27].y= H ;
    ptArray[28].x= ( C1 + d1 ) / 2.0 ;
    ptArray[28].y= h1 + h2 ;
    ptArray[29].x= ptArray[18].x - R1 ;
    ptArray[29].y= h1 + h2 ;
    ptArray[30].x= ptArray[18].x  ;
    ptArray[30].y= ptArray[29].y - R1 ;
    ptArray[31].x= ptArray[29].x  ;
    ptArray[31].y= h1 ;
    ptArray[32].x= ptArray[12].x  ;
    ptArray[32].y= h1 ;
    ptArray[33].x= C /2.0 + ( 2.0 *  R2 + b) / 2.0 ;
    ptArray[33].y= 0.0 ;
    ptArray[34].x= L / 2.0 ;
    ptArray[34].y= 0.0 ;
    ptArray[35].x= L / 2.0 ;
    ptArray[35].y= h - H1 ;
    ptArray[36].x= L/2 - 1;
    ptArray[36].y= h - H1 ;
    ptArray[37].x= ptArray[36].x - R1 ;
    ptArray[37].y= h - H1 + R1 ;
    ptArray[38].x= ptArray[37].x ;
    ptArray[38].y= h ;
    ptArray[39].x= ptArray[33].x ;
    ptArray[39].y= h ;
    ptArray[40].x= B2 / 2.0 ;
    ptArray[40].y= H2;
    ptArray[41].x= B2 / 2.0 ;
    ptArray[41].y= H;
    ptArray[42].x= - ptArray[41].x ;
    ptArray[42].y= H ;
    ptArray[43].x= - ptArray[40].x ;
    ptArray[43].y=  ptArray[40].y ;
    ptArray[44].x= - ptArray[25].x ;
    ptArray[44].y=  ptArray[43].y ;
    ptArray[45].x= - B4 / 2.0 ;
    ptArray[45].y= H2 ;
    ptArray[46].x= - ptArray[23].x ;
    ptArray[46].y= ptArray[23].y ;
    ptArray[47].x= - ptArray[22].x ;
    ptArray[47].y= ptArray[22].y ;
    ptArray[48].x= - ptArray[38].x ;
    ptArray[48].y= ptArray[38].y ;
    ptArray[49].x= - ptArray[37].x ;
    ptArray[49].y= ptArray[37].y ;
    ptArray[50].x= - ptArray[36].x ;
    ptArray[50].y= ptArray[36].y ;
    ptArray[51].x= - ptArray[35].x ;
    ptArray[51].y= ptArray[35].y ;
    ptArray[52].x= - ptArray[34].x ;
    ptArray[52].y= ptArray[34].y ;
    ptArray[53].x= - ptArray[18].x ;
    ptArray[53].y= ptArray[18].y ;
    ptArray[54].x= - ptArray[19].x ;
    ptArray[54].y= ptArray[19].y ;
    ptArray[55].x= - ptArray[31].x ;
    ptArray[55].y= ptArray[31].y ;
    ptArray[56].x= - ptArray[32].x ;
    ptArray[56].y= ptArray[32].y ;
    ptArray[57].x= - ptArray[10].x ;
    ptArray[57].y= ptArray[10].y ;
    ptArray[58].x= - ptArray[9].x ;
    ptArray[58].y= ptArray[9].y ;
    ptArray[59].x= - B3 / 2.0 ;
    ptArray[59].y= h + R1 ;
    ptArray[60].x= - B3 / 2.0 - R1 ;
    ptArray[60].y= h ;
    ptArray[61].x= - B3 / 2.0 ;
    ptArray[61].y= h - H1 + R1 ;
    ptArray[62].x= ptArray[60].x ;
    ptArray[62].y= h - H1 ;
    ptArray[63].x= D / 2.0 ;
    ptArray[63].y= H ;
    ptArray[64].x= - D / 2.0 ;
    ptArray[64].y= H ;
    ptArray[65].x= - D1 / 2.0 ;
    ptArray[65].y= H ;
    ptArray[66].x= - D2 / 2.0 ;
    ptArray[66].y= H ;
    ptArray[67].x= - D3 / 2.0 ;
    ptArray[67].y= H ;
    ptArray[68].x= D3 / 2.0 ;
    ptArray[68].y= H ;
    ptArray[69].x= 0.0 ;
    ptArray[69].y= H - D2 / 2.0 ;
    ptArray[70].x= 0.0 ;
    ptArray[70].y= H - D3 / 2.0 ;
    ptArray[71].x= ptArray[58].x ;
    ptArray[71].y= - 4 * e1 ;
    ptArray[72].x= ptArray[18].x ;
    ptArray[72].y= ptArray[71].y ;
    ptArray[73].x= ptArray[7].x ;
    ptArray[73].y= - 7 * e1 ;
    ptArray[74].x= ptArray[52].x ;
    ptArray[74].y= - 10 * e1 ;
    ptArray[75].x= ptArray[52].x - 7 * e1 ;
    ptArray[75].y= ptArray[42].y ;
    ptArray[76].x= ptArray[75].x - 3 * e1 ;
    ptArray[76].y= ptArray[45].y ;
    ptArray[77].x= ptArray[52].x - 4 * e1;
    ptArray[77].y= h ;
    ptArray[78].x= ptArray[64].x ;
    ptArray[78].y= H + 4 * e1 ;
    ptArray[79].x= ptArray[65].x ;
    ptArray[79].y= ptArray[78].y + 3 * e1 ;
    ptArray[80].x= ptArray[43].x ;
    ptArray[80].y= ptArray[79].y + 9 * e1  ;
    ptArray[81].x= ptArray[44].x ;
    ptArray[81].y= ptArray[79].y + 12 * e1  ;
    ptArray[82].x= ptArray[45].x ;
    ptArray[82].y= ptArray[79].y + 15 * e1  ;
    ptArray[83].x= ptArray[27].x ;
    ptArray[83].y= H2 ;
    ptArray[84].x= - ptArray[66].x ;
    ptArray[84].y= H ;
    ptArray[85].x= ptArray[67].x ;
    ptArray[85].y= ptArray[79].y + 6 * e1  ;
    ptArray[86].x= ptArray[66].x ;
    ptArray[86].y= ptArray[79].y + 3 * e1  ;
    ptArray[87].x= ptArray[31].x ;
    ptArray[87].y= ptArray[19].y ;
    ptArray[88].x= ptArray[56].x ;
    ptArray[88].y= ptArray[57].y ;
    Ospace[0] = floor( B7 / 4.0 ) ;
    Ospace[1] = Ospace[0];
    Ospace[2] = Ospace[0];
    Ospace[3] = Ospace[0];
    return(0);
} 

